Attribute VB_Name = "newColorDialog"
Option Explicit

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright 1996-2011 VBnet/Randy Birch, All Rights Reserved.
' Some pages may also contain other copyrights by the author.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Distribution: You can freely use this code in your own
'               applications, but you may not reproduce
'               or publish this code on any web site,
'               online service, or distribute as source
'               on any media without express permission.
' http://vbnet.mvps.org/index.html?code/hooks/choosecolorcustomize.htm
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Const WM_INITDIALOG As Long = &H110

'ChooseColor Dialog component control ID's
'dialog buttons
Private Const CTLID_BTN_OK  As Long = 1
Private Const CTLID_BTN_CANCEL  As Long = 2
Private Const CTLID_BTN_ADDTOCUSTOMCOLORS As Long = &H2C8
Private Const CTLID_BTN_DEFINECUSTOMCOLORS As Long = &H2CF

'labels
Private Const CTLID_LABEL_HUE As Long = &H2D3
Private Const CTLID_LABEL_SAT As Long = &H2D4
Private Const CTLID_LABEL_LUM As Long = &H2D5
Private Const CTLID_LABEL_RED As Long = &H2D6
Private Const CTLID_LABEL_BLUE As Long = &H2D7
Private Const CTLID_LABEL_GREEN As Long = &H2D8

'text boxes
Private Const CTLID_VALUE_HUE As Long = &H2BF
Private Const CTLID_VALUE_SAT As Long = &H2C0
Private Const CTLID_VALUE_LUM As Long = &H2C1
Private Const CTLID_VALUE_RED As Long = &H2C2
Private Const CTLID_VALUE_BLUE As Long = &H2C3
Private Const CTLID_VALUE_GREENE As Long = &H2C4

'palettes / selectors
Private Const CTLID_PALETTE_BASICCOLORS As Long = &H2D0
Private Const CTLID_PALETTE_CUSTOM_COLORS As Long = &H2D1
Private Const CTLID_PALETTE_CUSTOMRAINBOW As Long = &H2C6
Private Const CTLID_PALETTE_CUSTOMDENSITY As Long = &H2BE

Private Declare Function GetDlgItem Lib "user32" _
 (ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long
  
Private Declare Function MoveWindow Lib "user32" _
 (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, _
  ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
  
Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" _
 (ByVal hwnd As Long, ByVal lpString As String) As Long
  
Private Declare Function GetWindowRect Lib "user32" _
 (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
 (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Enum stdPositions
    LeftTop
    RightTop
    LeftBottom
    RightBottom
    Center
    Custom
End Enum

Public thePosition As Integer
Public newRect As RECT
Dim oldRect As RECT

Public Function FARPROC(ByVal pfn As Long) As Long
 'Procedure that receives and returns
 'the passed value of the AddressOf operator.

 'This workaround is needed as you can't assign
 'AddressOf directly to a member of a user-
 'defined type, but you can assign it to another
 'long and use that (as returned here)
  FARPROC = pfn
End Function

Public Function ChooseColorProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, _
                               ByVal lParam As Long) As Long
  Dim hwndctl As Long
  Dim scrWidth, scrHeight, dlgWidth, dlgHeight As Long
  
  Select Case uMsg
     Case WM_INITDIALOG
       'centre the dialog on the screen
        Call GetWindowRect(hwnd, oldRect)
        
        scrWidth = Application.Width
        scrHeight = Application.Height
        dlgWidth = oldRect.Right - oldRect.Left
        dlgHeight = oldRect.Bottom - oldRect.Top
        
        Select Case thePosition
            Case LeftTop
                Call MoveWindow(hwnd, 0, 0, dlgWidth, dlgHeight, 1)
            Case RightTop
                Call MoveWindow(hwnd, scrWidth - dlgWidth, 0, dlgWidth, dlgHeight, 1)
            Case LeftBottom
                Call MoveWindow(hwnd, 0, scrHeight - dlgHeight, dlgWidth, dlgHeight, 1)
            Case RightBottom
                Call MoveWindow(hwnd, scrWidth - dlgWidth, scrHeight - dlgHeight, _
                    dlgWidth, dlgHeight, 1)
            Case Center
                Call MoveWindow(hwnd, (scrWidth - dlgWidth) / 2, (scrHeight - dlgHeight) / 2, _
                    dlgWidth, dlgHeight, 1)
            Case Custom
                Call MoveWindow(hwnd, newRect.Left, newRect.Top, dlgWidth, dlgHeight, 1)
        End Select
              
       'customize the dialog caption
'         Call SetWindowText(hwnd, "VBnet ChooseColor Demo")
        
       'alter the text on the OK, CANCEL
       'Define and Add buttons
'         hwndctl = GetDlgItem(hwnd, CTLID_BTN_OK)
'         Call SetWindowText(hwndctl, "Apply")
'
'         hwndctl = GetDlgItem(hwnd, CTLID_BTN_CANCEL)
'         Call SetWindowText(hwndctl, "Bail Out")
'
'         hwndctl = GetDlgItem(hwnd, CTLID_BTN_CANCEL)
'         Call SetWindowText(hwndctl, "Bail Out")
'
'         hwndctl = GetDlgItem(hwnd, CTLID_BTN_DEFINECUSTOMCOLORS)
'         Call SetWindowText(hwndctl, "Create a new color >>")
'
'         hwndctl = GetDlgItem(hwnd, CTLID_BTN_ADDTOCUSTOMCOLORS)
'         Call SetWindowText(hwndctl, "Add as a new color")
        
        ChooseColorProc = 1
     Case Else
  End Select
End Function

